package jarnik.ld20
{
	import org.flixel.FlxG;
	import org.flixel.FlxObject;
	import org.flixel.FlxText;
	import org.flixel.FlxSprite;

	public class Creature extends FlxSprite
	{
        public function Creature( Img:Class, X:Number = 0, Y:Number = 0 ):void {
            super( X, Y );
            loadGraphic( Img, true, true );
            setSpeed( 80 );
            addAnimation("jump",[1]);
            addAnimation("stand",[0]);
            addAnimation("walk",[0,1],8);
            play("stand");
        }

        public function setSpeed(s:Number):void {
            maxVelocity.x = s;
            maxVelocity.y = 200;
            acceleration.y = 200;
            drag.x = maxVelocity.x * 4;
        }

        public function jump():void {
            if ( !isTouching( FlxObject.FLOOR ) )
                return;

            velocity.y = -maxVelocity.y/2;
        }

        override public function update():void {

            if ( isTouching( FlxObject.LEFT ) || isTouching( FlxObject.RIGHT ) )
                acceleration.x = 0;
 
            if ( acceleration.x > 0 && facing == FlxObject.LEFT )
                facing = FlxObject.RIGHT;
            if ( acceleration.x < 0 && facing == FlxObject.RIGHT )
                facing = FlxObject.LEFT;

            super.update();
        }

        protected function updateStance():void {
            if ( isTouching( FlxObject.FLOOR ) ) {
                if ( justTouched( FlxObject.FLOOR ) )
                    play("stand");                
                else if ( acceleration.x != 0 )
                    walk();
                else if ( acceleration.x == 0 )    
                    play("stand");
            } else {
                play("jump");
            }
        }

        private function walk():void {
            // show walk animation
            if ( _curAnim.name == "walk" )
                return;
            play("walk");
        }

	}
}
