package jarnik.ld20
{
	import org.flixel.FlxG;
	import org.flixel.FlxPoint;
	import org.flixel.FlxObject;
	import org.flixel.FlxText;
	import org.flixel.FlxSprite;

	public class Enemy extends Creature
	{
        private var jumpStart:FlxPoint;


        public function Enemy( Img:Class, X:Number = 0, Y:Number = 0, Facing:int = FlxObject.RIGHT ):void {
            super( Img, X, Y );
            width = 14;
            offset.x = 1;
            facing = Facing;
            jumpStart = new FlxPoint();
            setSpeed( 40 );
        }

        override public function update():void {
            if ( (jumpStart.x == x && jumpStart.y == y) ||
                 ( x > (PlayState.LEVEL_SIZE-1) * 16 && facing == FlxObject.RIGHT ) ||
                 ( x < 2 && facing == FlxObject.LEFT )  
            )
                turn();
            if ( isTouching(FlxObject.FLOOR) ) {
                if ( justTouched( FlxObject.RIGHT ) || justTouched( FlxObject.LEFT ) ) {
                   jumpStart.x = x;
                   jumpStart.y = y;
                   jump();
                }
            }
            if ( !isTouching( facing ) )
                acceleration.x = maxVelocity.x*4 * ( facing == FlxObject.RIGHT ? 1 : -1 ) ;
            super.update();
        }

        private function turn():void {
            facing = (facing == FlxObject.LEFT? FlxObject.RIGHT : FlxObject.LEFT );
        }

	}
}
